/* util.c generated by valac 0.48.17, the Vala compiler
 * generated from util.vala, do not modify */

#include <stdlib.h>
#include <string.h>
#include <glib.h>

glong xmpp_util_from_hex (const gchar* numeral);

/**
  * Parse a number from a hexadecimal representation.
  *
  * Skips any whitespace at the start of the string, parses as many valid
  * characters as hexadecimal digits as possible (possibly zero) and returns
  * them as an integer value.
  *
  * ```
  * // 0xa
  * print("0x%lx\n", from_hex("A quick brown fox jumps over the lazy dog."));
  * ```
  */
static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1555 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1556 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1556 "glib-2.0.vapi"
	res_length1 = -1;
#line 1556 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1557 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1557 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1557 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1558 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1558 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1558 "glib-2.0.vapi"
	if (result_length1) {
#line 1558 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 57 "util.c"
	}
#line 1558 "glib-2.0.vapi"
	result = _tmp2_;
#line 1558 "glib-2.0.vapi"
	return result;
#line 63 "util.c"
}

glong
xmpp_util_from_hex (const gchar* numeral)
{
	glong _result_ = 0L;
	gboolean skipping_whitespace = FALSE;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	guint8* _tmp2_;
	gint _tmp2__length1;
	glong result = 0L;
#line 16 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
	g_return_val_if_fail (numeral != NULL, 0L);
#line 17 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
	_result_ = (glong) 0;
#line 18 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
	skipping_whitespace = TRUE;
#line 19 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
	_tmp0_ = string_get_data (numeral, &_tmp1_);
#line 19 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
	_tmp0__length1 = _tmp1_;
#line 19 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
	_tmp2_ = _tmp0_;
#line 19 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
	_tmp2__length1 = _tmp0__length1;
#line 91 "util.c"
	{
		guint8* byte_collection = NULL;
		gint byte_collection_length1 = 0;
		gint _byte_collection_size_ = 0;
		gint byte_it = 0;
#line 19 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
		byte_collection = _tmp2_;
#line 19 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
		byte_collection_length1 = _tmp2__length1;
#line 19 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
		for (byte_it = 0; byte_it < byte_collection_length1; byte_it = byte_it + 1) {
#line 103 "util.c"
			guint8 byte = 0U;
#line 19 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
			byte = byte_collection[byte_it];
#line 107 "util.c"
			{
				gchar c = '\0';
				gboolean _tmp3_ = FALSE;
				gint digit = 0;
				gboolean _tmp4_ = FALSE;
#line 20 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
				c = (gchar) byte;
#line 21 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
				if (skipping_whitespace) {
#line 21 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
					_tmp3_ = g_ascii_isspace (c);
#line 119 "util.c"
				} else {
#line 21 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
					_tmp3_ = FALSE;
#line 123 "util.c"
				}
#line 21 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
				if (_tmp3_) {
#line 22 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
					continue;
#line 129 "util.c"
				}
#line 24 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
				skipping_whitespace = FALSE;
#line 26 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
				if ('0' <= c) {
#line 26 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
					_tmp4_ = c <= '9';
#line 137 "util.c"
				} else {
#line 26 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
					_tmp4_ = FALSE;
#line 141 "util.c"
				}
#line 26 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
				if (_tmp4_) {
#line 27 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
					digit = (gint) (c - '0');
#line 147 "util.c"
				} else {
					gboolean _tmp5_ = FALSE;
#line 28 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
					if ('A' <= c) {
#line 28 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
						_tmp5_ = c <= 'F';
#line 154 "util.c"
					} else {
#line 28 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
						_tmp5_ = FALSE;
#line 158 "util.c"
					}
#line 28 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
					if (_tmp5_) {
#line 29 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
						digit = (c - 'A') + 10;
#line 164 "util.c"
					} else {
						gboolean _tmp6_ = FALSE;
#line 30 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
						if ('a' <= c) {
#line 30 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
							_tmp6_ = c <= 'f';
#line 171 "util.c"
						} else {
#line 30 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
							_tmp6_ = FALSE;
#line 175 "util.c"
						}
#line 30 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
						if (_tmp6_) {
#line 31 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
							digit = (c - 'a') + 10;
#line 181 "util.c"
						} else {
#line 33 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
							break;
#line 185 "util.c"
						}
					}
				}
#line 35 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
				_result_ = (_result_ << 4) | digit;
#line 191 "util.c"
			}
		}
	}
#line 37 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
	result = _result_;
#line 37 "/builddir/build/BUILD/dino-0.1.2/xmpp-vala/src/util.vala"
	return result;
#line 199 "util.c"
}

